from typing import Optional

from pystac import Item
from registrar.abc import Backend
from registrar.source import Source


class MyPathBackend(Backend[str]):
    def __init__(self, exists: False):
        self.exists = exists

    def exists(self, source: Optional[Source], path: str) -> bool:
        return self.exists

    def register(self, source: Optional[Source], path: str, replace: bool):
        ...

    def deregister(self, source: Optional[Source], path: str) -> Optional[str]:
        return path

    def deregister_identifier(self, identifier: str) -> Optional[str]:
        return identifier

class MyItemBackend(Backend[Item]):
    def __init__(self, exists: False):
        self._exists = exists

    def exists(self, source: Optional[Source], item: "Item") -> bool:
        return self._exists

    def register(self, source: Optional[Source], item: "Item", replace: bool):
        ...

    def deregister(self, source: Optional[Source], path: str) -> Optional[str]:
        return path

    def deregister_identifier(self, identifier: str) -> Optional[str]:
        return identifier
